/*
 * ChangeEmitter.java  $Revision: 1.5 $  $Date: 2007/10/03 04:59:32 $
 *
 * Copyright (C) 2007 Meldcraft Corporation
 *
 * This file is part of Scaffold.
 * 
 * Scaffold is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Scaffold is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Scaffold.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.meldcraft.application.guis.mvc;

import java.awt.Component;
import java.lang.reflect.InvocationTargetException;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import com.meldcraft.application.ApplicationContext;
import com.meldcraft.util.ReflectUtil;

/**
 * @version $Revision: 1.5 $ $Date: 2007/10/03 04:59:32 $
 * @author Rob Richards
 */
public class ChangeEmitter extends MVCSupport implements ChangeListener
{
    private ApplicationContext  mContext;
    private String              mContextKey;

    public ChangeEmitter(ApplicationContext context, String elementId, String contextKey, Component comp)
    {
        super(context, elementId);

        mContext = context;
        mContextKey = contextKey;

        try
        {
            ReflectUtil.invokeMethod(comp, "addChangeListener", this);
        }
        catch (NoSuchMethodException e)
        {
            throw new RuntimeException("Could not addChangeListener", e);
        }
        catch (IllegalAccessException e)
        {
            throw new RuntimeException("Could not addChangeListener", e);
        }
        catch (InvocationTargetException e)
        {
            throw new RuntimeException("Could not addChangeListener", e);
        }
    }

    public void stateChanged(ChangeEvent e)
    {
        Object src = e.getSource();
        try
        {
            Object curVal = ReflectUtil.invokeMethod(src, "getValue");
            emitContextChanged(mContext, mContextKey + ".change", getEmitValue(mContext, curVal));
        }
        catch (NoSuchMethodException e1)
        {
        }
        catch (IllegalAccessException e1)
        {
        }
        catch (InvocationTargetException e1)
        {
        }
    }
}



